# Copyright(c) 1998, Space Science and Engineering Center, UW-Madison
# Refer to "McIDAS Software Acquisition and Distribution Policies"
# in the file  mcidas/data/license.txt

# $Id: VerifyLoggedOn.tcl,v 1.2 1998/10/13 20:26:21 dglo Exp $

# VerifyLoggedOn.tcl
#

# VerifyLoggedOn datatype group
#	datatype	-- datatype that DSINFO command will be looking for  
#	group	-- group that DSINFO command will be looking for 
#
#	VerifyLoggedon runs the DSINFO command to verify that the user is logged on
#	if not the first string returned will be "DSINFO: Accounting data was not valid"
#	if this string is found then 0 is returned 
#	else 1 is returned indicating that the user IS logged on
#

proc VerifyLoggedOn { datatype group }  \
   {
   # get pipe to the DSINFO command 
      set f_dsinfo [open "|dsinfo.k $datatype $group" r]
      
   # if the first string contains "Accounting data was not valid" return 0  
      gets $f_dsinfo testString 
   # now empty the pipe -- read the rest of the text data until empty string returned  
      while { [gets $f_dsinfo BurnTillDone] != -1 } { }
      if { [string first "Accounting data was not valid" $testString] != -1 } \
         {
         # Don't bother checking return status of message box -- only want message to be acknowledged anyway
         tk_messageBox  -title "Data Set Error" -message "You are not logged on. \nPlease log on and try again" \
	          -type ok -parent .  -icon warning   			
            return 0
         }   
    # else in the clear -- are logged on     
      return 1  
   }

