#!/usr/local/tcl/bin/mcwish -f

# Copyright(c) 1998, Space Science and Engineering Center, UW-Madison
# Refer to "McIDAS Software Acquisition and Distribution Policies"
# in the file  mcidas/data/license.txt

# $Id: getnamedcolor.tcl,v 1.9 1998/10/13 20:26:31 dglo Exp $

proc finishNamedColor {{swatch "X"} {var ""} } {
    global colorname
    global reds
    global greens
    global blues
    global names

    set color [selection get]
    set cname [lindex $color 0]


    foreach ind [array names names] {
	if {$names($ind) == $cname} {
		set rgb [format "#%02x%02x%02x" $reds($ind) $greens($ind) $blues($ind)]
	}
    }
    if {$swatch != "X"} {
	global $swatch
	$swatch configure -bg $rgb
    }

    set colorname [string trim [lindex [selection get] 0]]
    destroy .colors

    if {$var != ""} {
	global $var

	set $var $colorname
    }
}

proc GetNamedColor {{swatch "X"} {colorvar ""}} {
#
#	Let user know this will take a while
#
    showBusyStatus

    catch {destroy .colors}
    toplevel .colors
    wm title .colors "Color Listing"
    wm iconname .colors "Colors"
    wm minsize .colors 1 1
    placepopup .colors
    message .colors.msg -font -Adobe-times-medium-r-normal--*-180* \
	-aspect 500 -text "Double click to select color."
    pack .colors.msg -side top -fill x

    frame .colors.frame -borderwidth 10
    scrollbar .colors.frame.scroll -relief sunken \
	-command ".colors.frame.list yview"
    listbox .colors.frame.list -yscroll ".colors.frame.scroll set" \
	-relief sunken -width 20 -height 10 -setgrid 1
    pack append .colors.frame .colors.frame.scroll {right filly} \
	    .colors.frame.list {left expand fill}
    pack .colors.frame -side top

    set collist [open [mcidas pathname MCRGB.TXT] r]

    global lab1
    label .colors.label1  -width 20
    pack .colors.label1 -side top -anchor w

    global i
    global reds
    global greens
    global names
    global blues
    set i 0
    while {[gets $collist line] > -1} {
	.colors.frame.list insert end [lindex $line 3]
	set names($i)  [lindex $line 3]
	set reds($i) [lindex $line 0]
	set greens($i) [lindex $line 1]
	set blues($i) [lindex $line 2]
	incr i
    }

    global colorname
    catch {close $collist}

    bind .colors.frame.list <Double-1> "finishNamedColor  $swatch $colorvar "

    button .colors.ok -text Dismiss -command "destroy .colors"
    pack .colors.ok -side bottom
#
#	Let user know we're done.
#
    showIdleStatus
}

proc debugGetNamedColor {{top .}} {
    global env
    global auto_path
    global guipath
    global mycolor
    global colorname

    set guipath "$env(HOME)/mcidas/guidev"
    set auto_path "$guipath $auto_path"

    if {[catch "winfo toplevel $top"] != 0} {
	toplevel $top
    }

    if {$top == "."} {
	set wtop ""
    } else {
	set wtop $top
    }

    if ![info exists mycolor] {
	set mycolor ""
    }
    if ![info exists colorname] {
	set colorname ""
    }

    initStatus $wtop.label
    button $wtop.novar -text "No variable" \
	-command "GetNamedColor $wtop.label"
    button $wtop.var -text "Variable" \
	-command "GetNamedColor $wtop.label mycolor"
    button $wtop.dump -text Dump \
	-command {puts "colorname \"$colorname\", mycolor \"$mycolor\""}
    button $wtop.done -text Done -command {destroy .}

    if [winfo exists $wtop.label] {
      pack $wtop.label
    }

    pack $wtop.label $wtop.novar $wtop.var $wtop.dump $wtop.done

    puts "colorname \"$colorname\", mycolor \"$mycolor\""
}
