#!/bin/false

# Copyright(c) 1998, Space Science and Engineering Center, UW-Madison
# Refer to "McIDAS Software Acquisition and Distribution Policies"
# in the file  mcidas/data/license.txt

# $Id: initimage.tcl,v 1.22 2005/01/24 20:30:14 tsmith Exp $

# Attempt to grab a McIDAS image window and subsume it into a Tk window
proc initImage { mcimageWindowFrame } \
{
  # Get X ID for image window associated with this session
  set imageid [UCpeek image_window_id]
  for {set i 0} {$imageid == 0 && $i < 5} {incr i} \
  {
    exec sleep 1
    set imageid [UCpeek image_window_id]
  }
  
  if {$imageid == 0} \
  {
    puts stderr "No image window associated with this McIDAS session"
    exit 1
  }

  # Sleep a bit to avoid grabbing image window before it's fully realized
  exec sleep 2

  if [catch {set geom [xinfo geometry $imageid]}] \
  {
    puts stderr "Bad X ID $imageid for image window"
    exit 1
  }

  # Figure out how large the frame needs to be
  regexp {([0-9]+)x([0-9]+)} $geom full width height

  set xloc 0
  set yloc 0
  set win $imageid
  set root [xinfo root]
  
  while { 1 } \
  {
    set p [xinfo parent $win]
    if {$p == $root} { break }
    if {[llength [xinfo properties $p]] != 0} { break }
    set kid $win
    set win $p
  }

  if { ![catch {set pgeom [xinfo geometry $win]}] } \
  {
    regexp {[0-9]+x[0-9]+.([0-9]+).([0-9]+)} $pgeom full xloc yloc
  }

  update idletasks

  # Grab the image window
  xwindow $mcimageWindowFrame.mcimage $imageid
  pack $mcimageWindowFrame.mcimage

  # If image window configures itself, undo any user-specified configuration
  set top [winfo toplevel $mcimageWindowFrame]
  bind $mcimageWindowFrame.mcimage <Configure> "wm geometry $top {}"

  # If image window destroys itself, kill parent
  bind $mcimageWindowFrame.mcimage <Destroy> "killkids; destroy $top"

  # Set title and icon name to those of the image window
  wm iconname $top [xinfo iconname $imageid]
  wm title $top [xinfo title $imageid]
  wm geometry $top "+$xloc+$yloc"
}
