# Copyright(c) 1998, Space Science and Engineering Center, UW-Madison
# Refer to "McIDAS Software Acquisition and Distribution Policies"
# in the file  mcidas/data/license.txt

# $Id: pickframe.tcl,v 1.11 1998/10/13 20:26:44 dglo Exp $

# Create a top-level window containing a listbox showing a bunch of
# McIDAS frames
#
# Arguments:



proc pickGuts {clickCmd} {
    catch {destroy .pickfrm}
    toplevel .pickfrm
    wm title .pickfrm "Frame Listing"
    wm iconname .pickfrm "Frames"
    wm minsize .pickfrm 1 1
    placepopup .pickfrm
    message .pickfrm.msg -font -Adobe-times-medium-r-normal--*-180* \
	-aspect 700 -text "Double click to select frame."
    frame .pickfrm.frame -borderwidth 10
    scrollbar .pickfrm.frame.scroll -relief sunken \
	-command ".pickfrm.frame.list yview"
    listbox .pickfrm.frame.list -yscroll ".pickfrm.frame.scroll set" \
	-relief sunken \
	-width 82 -height 10 -setgrid 1
    pack append .pickfrm.frame .pickfrm.frame.scroll {right filly} \
	    .pickfrm.frame.list {left expand fill}
set totframes [UCpeek number_of_frames]
set lflist [open "|frmlist.k 1 $totframes" r]

gets $lflist lab1
label .pickfrm.label1 -width 82 -text $lab1 -anchor w
gets $lflist lab2
label .pickfrm.label2 -width 82 -text $lab2 -anchor w
gets $lflist junk

while {[gets $lflist line] > -1} {
	if { [string first Done $line] == -1} {
	.pickfrm.frame.list insert end  $line}
}
catch {close $lflist}

bind .pickfrm.frame.list <Double-1> "
  set tmp \[lindex \[selection get\] 0\]
  destroy .pickfrm

  if \[regexp {(\[0-9\])+} \$tmp num\] {
    $clickCmd \$num
  } else {
    $clickCmd \$tmp
  }
"

    button .pickfrm.ok -text Dismiss -command "destroy .pickfrm"
pack .pickfrm.msg -side top -fill x
pack .pickfrm.label1 -side top -anchor w
pack .pickfrm.label2 -side top -anchor w
pack .pickfrm.frame -side top
pack .pickfrm.ok -side bottom
}

proc setDFrame {num} {
  global dframe

  set dframe $num
}

proc pickframe {} {
  pickGuts setDFrame
}

proc showPickedFrame {num} {
  setImageFrame $num
}

proc pickAndShowFrame {} {
  pickGuts showPickedFrame
}
