#!/bin/false

# Copyright(c) 2003, Space Science and Engineering Center, UW-Madison
# Refer to "McIDAS Software Acquisition and Distribution Policies"
# in the file  mcidas/data/license.txt

# $Id: setoptions.tcl,v 1.16 2005/03/23 16:06:41 tsmith Exp $

proc defaultOptions {} {
	global back
	global fore
	global activeback
	global activefore
	global mand
	global messfont
	global smallfont
	global smallerfont
	global listboxfont

	set back "gray90"
	set activeback "white"
  	set fore "black"
	set activefore "black"
	set mand "gray80"
	set messfont "-adobe-courier-bold-r-normal--*-140*"
	set smallfont "-adobe-courier-bold-r-normal--*-70*"
	set smallerfont "-adobe-helvetica-medium-r-normal--*-75*"
	set listboxfont "-adobe-courier-bold-r-normal--*-70*"

	option add {*background} $back
	option add {*foreground} $fore
	option add {*mandatoryfield} $mand
	option add {*messageFont} $messfont
#	option add {*activeBackground} {navy}
	option add {*activeBackground} {white}
#	option add {*activeForeground} {yellow}
	option add {*activeForeground} {black}
	option add {*font} {-adobe-helvetica-bold-r-normal--*-70*}
     #--- from CommonProcs.tcl all Listboxes will have an lList member for the list box	
	option add {*Listbox.font} $listboxfont
	option add *Menu.font {-adobe-courier-bold-r-normal--*-70*}
	option add {*highlightthickness} 0 
	
#	xlsfonts
}

proc readOptions {rcname} {
	global back
	global fore
	global mand
	global messfont

	if ![file exists $rcname] {
		return 0
	}

	set options [open $rcname r]

	while {[gets $options optline] >= 0} {

		if {![regexp {^[ 	]*$} $optline] &&
			![regexp {^[ 	]*#} $optline]} {

			set name [lindex $optline 0]
			set value [lindex $optline 1]

			if {$name == "*mandatoryfield"} {
				set mand $value
			} elseif {$name == "*messageFont"} {
				set messfont $value
			} elseif {$name == "*background"} {
				set back $value
			} elseif {$name == "*foreground"} {
				set fore $value
			}

			option add $name $value
		}
	}
	close $options
	return 1
}

proc setoptions {} {
	global env

	# look for resource file
	#
	if [info exists env(HOME)] {
		set home $env(HOME)
	} else {
		set home "/"
	}

	defaultOptions
	if [readOptions "$home/.mcguirc"] {
		return
	}
	if [readOptions ".mcguirc"] {
		return
	}
}
