# Copyright(c) 1998, Space Science and Engineering Center, UW-Madison
# Refer to "McIDAS Software Acquisition and Distribution Policies"
# in the file  mcidas/data/license.txt

# $Id: ucval.tcl,v 1.10 1998/10/13 20:26:53 dglo Exp $

#	UCpeek index
#
#	get value from User Common at inex
#
#	Arguments:
#		index - index of value to obtain
#
#		return- value at index in UC
#



proc UCpeek {name} {

  # translate location name to actual index
  #
  set index [ucLocation $name]

  if [running_mcwish] {
    return [mcidas peek $index]
  } else {
    set ucupeek [open "|ucu.k PEEK $index" r]
    gets $ucupeek line
    catch {close $ucupeek}
    if {[scan $line {UC[%d] Current value DEC : %d} idx value] != 2} {
      return -1;
    }
    if {$idx != $index} {
      return -1;
    }
    return $value
  }
}

proc UCpoke {name value {charflag ""}} {

  # translate location name to actual index
  #
  set index [ucLocation $name]

  if [running_mcwish] {
    return [eval mcidas poke $index $charflag $value]
  } else {
    if {$charflag != ""} {
      error "UCpoke does not support $charflag"
    }
    set ucupeek [open "|ucu.k POKE $index $value" r]
    gets $ucupeek prev
    gets $ucupeek curr
    catch {close $ucupeek}
    if {[scan $prev {UC[%d] Previous value DEC : %d} idx val] != 2} {
      return 0;
    }
    if {$idx != $index} {
      return 0;
    }
    if {[scan $curr {UC[%d] Current value DEC : %d} idx val] != 2} {
      return 0;
    }
    if {$idx != $index} {
      return 0;
    }
    if {$val != $value} {
      return 0
    }
  }
  return 1
}
